Index: Schedules.vb
===================================================================
--- Schedules.vb	(revision 518)
+++ Schedules.vb	(working copy)
@@ -17,6 +17,7 @@
 
 
 Imports TvDatabase
+Imports TvPlugin
 
 Namespace uWiMP.TVServer
 
@@ -62,13 +63,39 @@
             Return False
 
         End Function
+        ' return all the upcoming recordings for a given list of schedules
+        Public Shared Function GetRecordingsForSchedule(ByVal l As List(Of Schedule)) As List(Of Schedule)
+            Dim retL As List(Of Schedule) = New List(Of Schedule)
+            Dim tvp As TvPlugin.TVUtil = New TvPlugin.TVUtil()
+            For Each s In l
+                ' get all the recordings for this schedule
+                Dim l1 As List(Of Schedule) = tvp.GetRecordingTimes(s)
+                For Each ss In l1
+                    ' add each recording to the list to return
+                    retL.Add(ss)
+                Next
+            Next
 
+            ' sort the list
+            retL.Sort(New uWiMP.TVServer.ScheduleStartTimeComparerDesc)
+
+            Return retL
+
+        End Function
+
         Public Shared Function GetSchedules() As List(Of Schedule)
 
-            Return Schedule.ListAll
+            Dim l As List(Of Schedule) = Schedule.ListAll
+            Dim retL As List(Of Schedule) = GetRecordingsForSchedule(l)
 
+
+            
+
+            Return retL
+
         End Function
 
+
         Public Shared Function GetScheduleById(ByVal idSchedule As Integer) As Schedule
 
             Return Schedule.Retrieve(idSchedule)
@@ -78,9 +105,10 @@
         Public Shared Function GetSchedulesForChannel(ByVal idChannel As Integer) As List(Of Schedule)
 
             Dim scheds As List(Of Schedule) = Schedule.ListAll
+            Dim recs As List(Of Schedule) = GetRecordingsForSchedule(scheds)
             Dim channelScheds As New List(Of Schedule)
 
-            For Each s As Schedule In scheds
+            For Each s As Schedule In recs
                 If s.IdChannel = idChannel Then channelScheds.Add(s)
             Next
 
@@ -91,9 +119,10 @@
         Public Shared Function GetSchedulesForTitle(ByVal title As String) As List(Of Schedule)
 
             Dim scheds As List(Of Schedule) = Schedule.ListAll
+            Dim recs As List(Of Schedule) = GetRecordingsForSchedule(scheds)
             Dim titleSched As New List(Of Schedule)
 
-            For Each s As Schedule In scheds
+            For Each s As Schedule In recs
                 If s.ProgramName.ToLower = title.ToLower Then titleSched.Add(s)
             Next
             If titleSched.Count > 1 Then titleSched.Sort(New uWiMP.TVServer.ScheduleStartTimeComparer)
